<template>
  <a-spin :spinning="confirmLoading">
    <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
      <a-row>
        <a-col :span="24">
          <a-form-item label="外链表" v-bind="validateInfos.outerChainDetectionId">
            <JSelectLinkOuterSysSet v-model:value="formData.outerChainDetectionId" ></JSelectLinkOuterSysSet>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="主站点" v-bind="validateInfos.mainSiteId">
            <JSelectLinkSysSet v-model:value="formData.mainSiteId" ></JSelectLinkSysSet>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="外链地址" v-bind="validateInfos.outerUrl">
	          <a-textarea v-model:value="formData.outerUrl" rows="4" placeholder="请输入外链地址" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="外链地址类型" v-bind="validateInfos.outerUrlType">
            <a-input v-model:value="formData.outerUrlType" placeholder="请输入外链地址类型" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="外链地址状态" v-bind="validateInfos.outerUrlState">
            <a-input v-model:value="formData.outerUrlState" placeholder="请输入外链地址状态" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="引用页面数" v-bind="validateInfos.numberApplicationPages">
	          <a-input-number v-model:value="formData.numberApplicationPages" placeholder="请输入引用页面数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="扫描次数" v-bind="validateInfos.numberScans">
	          <a-input-number v-model:value="formData.numberScans" placeholder="请输入扫描次数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="是否修改" v-bind="validateInfos.isRevise">
            <j-dict-select-tag type='radio' v-model:value="formData.isRevise" dictCode="verify_status" placeholder="请选择是否修改" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="是否忽略" v-bind="validateInfos.isIgnore">
            <j-dict-select-tag type='radio' v-model:value="formData.isIgnore" dictCode="verify_status" placeholder="请选择是否忽略" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="复核时间" v-bind="validateInfos.checkTime">
		        <a-date-picker placeholder="请选择复核时间" v-model:value="formData.checkTime" value-format="YYYY-MM-DD"  style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="复核状态" v-bind="validateInfos.checkState">
            <j-dict-select-tag type='radio' v-model:value="formData.checkState" dictCode="review_status" placeholder="请选择复核状态" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="复核引用页面数" v-bind="validateInfos.checkNumberApplicationPagesv">
	          <a-input-number v-model:value="formData.checkNumberApplicationPagesv" placeholder="请输入复核引用页面数" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="复核信息" v-bind="validateInfos.checkMessage">
            <a-input v-model:value="formData.checkMessage" placeholder="请输入复核信息" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </a-spin>
</template>

<script lang="ts" setup>
  import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
  import { defHttp } from '/@/utils/http/axios';
  import { useMessage } from '/@/hooks/web/useMessage';
  import JDictSelectTag from '/@/components/Form/src/jeecg/components/JDictSelectTag.vue';
  import { getValueType } from '/@/utils';
  import { saveOrUpdate } from '../LinkOuterChainLog.api';
  import { Form } from 'ant-design-vue';
  import JSelectLinkSysSet from '/@/components/Form/src/jeecg/components/JSelectLinkSysSet.vue';
  import JSelectLinkOuterSysSet from '/@/components/Form/src/jeecg/components/JSelectLinkOuterSysSet.vue';
  const props = defineProps({
    formDisabled: { type: Boolean, default: false },
    formData: { type: Object, default: ()=>{} },
    formBpm: { type: Boolean, default: true }
  });
  const formRef = ref();
  const useForm = Form.useForm;
  const emit = defineEmits(['register', 'ok']);
  const formData = reactive<Record<string, any>>({
    id: '',
    outerChainDetectionId: '',
    mainSiteId: '',
    mainSiteName: '',
    mainSiteUrl: '',
    outerUrl: '',
    outerUrlType: '',
    outerUrlState: '',
    numberApplicationPages: undefined,
    numberScans: undefined,
    isRevise: '',
    isIgnore: '',
    checkTime: '',
    checkState: '',
    checkNumberApplicationPagesv: undefined,
    checkMessage: '',
  });
  const { createMessage } = useMessage();
  const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
  const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
  const confirmLoading = ref<boolean>(false);
  //表单验证
  const validatorRules = {
    outerChainDetectionId: [{ required: true, message: '请输入外链表信息!'},],
    mainSiteId: [{ required: true, message: '请输入主站点!'},],
    outerUrl: [{ required: true, message: '请输入外链地址!'},],
    outerUrlType: [{ required: true, message: '请输入外链地址类型!'},],
    outerUrlState: [{ required: true, message: '请输入外链地址状态!'},],
    numberApplicationPages: [{ required: true, message: '请输入引用页面数!'},],
    numberScans: [{ required: true, message: '请输入扫描次数!'},],
    isRevise: [{ required: true, message: '请输入是否修改!'},],
    isIgnore: [{ required: true, message: '请输入是否忽略!'},],
    checkTime: [{ required: true, message: '请输入复核时间!'},],
    checkState: [{ required: true, message: '请输入复核状态!'},],
    checkNumberApplicationPagesv: [{ required: true, message: '请输入复核引用页面数!'},],
    checkMessage: [{ required: true, message: '请输入复核信息!'},],
  };
  const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: true });

  // 表单禁用
  const disabled = computed(()=>{
    if(props.formBpm === true){
      if(props.formData.disabled === false){
        return false;
      }else{
        return true;
      }
    }
    return props.formDisabled;
  });


  /**
   * 新增
   */
  function add() {
    edit({});
  }

  /**
   * 编辑
   */
  function edit(record) {
    nextTick(() => {
      resetFields();
      //赋值
      Object.assign(formData, record);
    });
  }

  /**
   * 提交数据
   */
  async function submitForm() {
    // 触发表单验证
    await validate();
    confirmLoading.value = true;
    const isUpdate = ref<boolean>(false);
    //时间格式化
    let model = formData;
    if (model.id) {
      isUpdate.value = true;
    }
    //循环数据
    for (let data in model) {
      //如果该数据是数组并且是字符串类型
      if (model[data] instanceof Array) {
        let valueType = getValueType(formRef.value.getProps, data);
        //如果是字符串类型的需要变成以逗号分割的字符串
        if (valueType === 'string') {
          model[data] = model[data].join(',');
        }
      }
    }
    await saveOrUpdate(model, isUpdate.value)
      .then((res) => {
        if (res.success) {
          createMessage.success(res.message);
          emit('ok');
        } else {
          createMessage.warning(res.message);
        }
      })
      .finally(() => {
        confirmLoading.value = false;
      });
  }


  defineExpose({
    add,
    edit,
    submitForm,
  });
</script>

<style lang="less" scoped>
  .antd-modal-form {
    min-height: 500px !important;
    overflow-y: auto;
    padding: 24px 24px 24px 24px;
  }
</style>
